require 'delayed_job_status/configuration'

module DelayedJobStatus
	  class << self
	    attr_accessor :configuration
	  end

	  def self.configuration
	    @configuration ||= Configuration.new
	  end

	  def self.reset
	    @configuration = Configuration.new
	  end

	  def self.configure
	    yield(configuration)
	  end


	def self.generateCode
		o = [('a'..'z'), ('A'..'Z')].map(&:to_a).flatten
		string = (0...50).map { o[rand(o.length)] }.join
		return string
	end

	def self.generateMessage
		code = generateCode
		website = getWebsiteinfo

		message_before = {server: website[:server], website: website[:website], workers: website[:workers], code: code}.to_json
		message_after = {server: website[:server], website: website[:website], workers: website[:workers], code: code}.to_json

		sendMessage(message_before)

		self.delay(priority: -200).sendMessage(message_after)
	end

	def self.sendMessage(m)
		uri = URI.parse(@configuration.url)
		http = Net::HTTP.new(uri.host, uri.port)
		http.use_ssl = true

		request = Net::HTTP::Post.new(uri.path, {'Content-Type' => 'application/json'})
		request.body = m

		response = http.request(request)
	end

	def self.getWebsiteinfo
		file = File.open("#{Rails.root}/config/deploy.rb")
		filetext = file.read
		num = filetext.split('delayed_job_workers,').last.strip().split("\n").first.strip
		website = filetext.split("application,").last.strip.split("\n").first.strip.gsub('"', '')
		return {workers: num, website: website, server: Socket.gethostname}
	end
end